LeetCode 300. Longest Increasing Subsequence

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?


解题思路:从前向后求出每个元素的递增序列个数,而当前 i 的递增序列个数需要扫描 0~i-1 的元素,找到比 i 元素的值小的元素,且递增序列数最大的数,再加1,就是当前 i 的递增序列个数。
public class Solution {
    public int lengthOfLIS(int[] nums) {
        if(nums.length<=0){
            return 0;
        }else{
            int []dp= new int[nums.length];
            dp[0]=1;
            int max=0;
            for(int i=0;i<nums.length;i++){
                max=0;
                for(int j=0;j<i;j++){
                    if(nums[j]<nums[i]){
                        max=max>dp[j]?max:dp[j];
                    }
                }
                dp[i]=max+1;
            }
            for(int i=0;i<dp.length;i++){
                max=max>=dp[i]?max:dp[i];
            }
            return max;
        }
    }
}

你可能感兴趣的:(LeetCode 300. Longest Increasing Subsequence)